﻿using Microsoft.Extensions.DependencyInjection;
using Spider.Core;
using Spider.Core.DataProvider;
using Spider.Core.Pipeline;
using Spider.Infrastructure;
using Spider.Services;

namespace Spider
{
    public class Bootstrapper
    {
        public static void RegisterServices(IServiceCollection container)
        {
            container.AddScoped<IWebDriverProvider, WebDriverProvider>();

            container.AddScoped<IDataProvider<Production>, ProductionDataProvider>();
            container.AddScoped<IDataProvider<User>, UserDataProvider>();

            container.AddScoped<IExtractable, Extractor>();
            container.AddScoped<ITransformable, Transformer>();
            container.AddScoped<ILoadable, Loader>();

            container.AddScoped<IExecutor, BasicExecutor>();
            container.AddScoped<IDataCollectProcessor, DataCollectBatchProcessor>();
            container.AddScoped<IDataCollectEngine, DataCollectEngine>();
        }
    }
}
