﻿using OpenQA.Selenium;
using OpenQA.Selenium.Chrome;
using System;

namespace Spider.Services
{
    public class WebDriverProvider : IWebDriverProvider
    {
        public IWebDriver Get(Browsers browsers)
        {
            var driver = default(IWebDriver);
            switch (browsers)
            {
                case Browsers.Chrome:
                    var options = new ChromeOptions();
                    //options.AddArgument("start-maximized");
                    // overcome limited resource problems
                    //options.AddArgument("--disable-dev-shm-usage");
                    // disabling extensions
                    //options.AddArgument("--disable-extensions");

                    if (AppEnvironment.IsStaging())// Linux
                    {
                        options.AddArgument("--no-sandbox");// Bypass OS security model
                        options.AddArgument("--disable-gpu");
                        options.AddArgument("--disable-extensions");
                        options.AddArgument("--headless");
                    }

                    var service = ChromeDriverService.CreateDefaultService();
                    driver = new ChromeDriver(service, options);
                    break;
                case Browsers.PhantomJs:

                    break;
                default:
                    throw new ArgumentOutOfRangeException(nameof(browsers), Enum.GetNames(typeof(Browsers)), null);
            }

            return driver;
        }
    }
}
